---
title: Path2D()
slug: Web/API/Path2D/Path2D
tags:
  - API
  - Canvas
  - Constructor
  - Drawing
  - Graphics
  - Path2D
  - Paths
  - Reference
---
<div>{{APIRef("Canvas API")}} {{seeCompatTable}}</div>

<p>The <code><strong>Path2D()</strong></code> constructor returns a newly instantiated <code>Path2D</code> object, optionally with another path as an argument (creates a copy), or optionally with a string consisting of <a href="/en-US/docs/Web/SVG/Tutorial/Paths">SVG path</a> data.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">new Path2D();
new Path2D(<em>path</em>);
new Path2D(<em>d</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>path</code> {{optional_inline}}</dt>
 <dd>When invoked with another <code>Path2D</code> object, a copy of the <code>path</code> argument is created.</dd>
 <dt><code>d</code> {{optional_inline}}</dt>
 <dd>When invoked with a string consisting of <a href="/en-US/docs/Web/SVG/Tutorial/Paths">SVG path</a> data, a new path is created from that description.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_and_copying_paths">Creating and copying paths</h3>

<p>This example creates and copies a <code>Path2D</code> path.</p>

<div class="hidden">
<pre class="brush: html notranslate">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;</pre>
</div>

<pre class="brush: js; highlight:[4,7] notranslate">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

let path1 = new Path2D();
path1.rect(10, 10, 100,100);

let path2 = new Path2D(path1);
path2.moveTo(220, 60);
path2.arc(170, 60, 50, 0, 2 * Math.PI);

ctx.stroke(path2);
</pre>

<p>{{ EmbedLiveSample('Creating_and_copying_paths', 700, 180) }}</p>

<h3 id="Using_SVG_paths">Using SVG paths</h3>

<p>This example creates a <code>Path2D</code> path using <a href="/en-US/docs/Web/SVG/Tutorial/Paths">SVG path data</a>. The path will move to point (<code>M10 10</code>) and then move horizontally 80 points to the right (<code>h 80</code>), then 80 points down (<code>v 80</code>), then 80 points to the left (<code>h -80</code>), and then back to the start (<code>Z</code>).</p>

<div class="hidden">
<pre class="brush: html notranslate">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;</pre>
</div>

<pre class="brush: js; highlight:[4] notranslate">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

let p = new Path2D('M10 10 h 80 v 80 h -80 Z');
ctx.fill(p);
</pre>

<p>{{ EmbedLiveSample('Using_SVG_paths', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#dom-path2d', 'Path2D()')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Path2D.Path2D")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Path2D")}}, the interface this constructor belongs to</li>
</ul>
